module Classes.Physics.Collectable where

-- | All kinds of Effects present in the game
data Effect
  = HealthUp
  | SpeedUp
  | JumpUp
  | ArmorUp
  | Antidote
  | StopTime
  | Invisibility

-- | The Effect holder type definition
data EffectHolder = EffectHolder
  { effectDuration :: Double -- ^ Duration of stored effect
  , effectReleased :: Effect -- ^ The actual effect released
  }

class Collidible c => Collectable c where

  effect
    :: c            -- ^ Collectable object
    -> EffectHolder -- ^ The descriptor of the effect contained
